/*
 * libkarma/properties.h
 * 
 * Copyright (c) Frank Zschockelt <libkarma@freakysoft.de> 2004
 * 
 * You may distribute and modify this program under the terms of 
 * the GNU GPL, version 2 or later.
 * 
 */
#include <inttypes.h>

#include "hash.h"

struct list{
	uint32_t fid;
	HASH * element;
	struct list * next;
};

struct klist{
	struct list * l;
	uint32_t count;
	uint32_t highest_fid;
};

void init_properties(void);
void destroy_properties(void);

uint32_t import_properties(char * properties);
char * export_property(uint32_t id);

uint32_t getnextfid(void);

uint32_t new_property(void);
int delete_property(uint32_t id);
char * get_property(uint32_t id, char * key);
char * get_property_hash(HASH * p, char * key);
int change_property(uint32_t id, char * property, char * data);
void change_property_hash(HASH * p, char * property, char * data);

HASH * idsearch(uint32_t fid);

int bool_search(char * in_prop, char * search_for);

