/*
 * libkarma/util.c
 *
 * Copyright (c) Frank Zschockelt <libkarma@freakysoft.de> 2004
 *
 * char *simple_itoa was borrowed from boa [http://www.boa.org]
 *
 * You may distribute and modify this program under the terms of 
 * the GNU GPL, version 2 or later.
 * 
 */
#include <stdlib.h>
#include <string.h>
#include "util.h"
/*
	 pads the data of **data to a 4 byte boundary with zero 
   and returns the length of the buffer
*/
uint32_t pad_4b(char ** data)
{
	uint32_t len;

	len=strlen(*data);
	if(len%4)
		*data=realloc(*data, sizeof(char)*(len+4-(len%4)+1));

	while(len++%4)
		(*data)[len] = '\0';

	return len-1;	
}

/*copied from the boa webserver*/
char *simple_itoa(unsigned int i)
{
	/* 21 digits plus null terminator, good for 64-bit or smaller ints
	 * for bigger ints, use a bigger buffer!
	 *
	 * 4294967295 is, incidentally, MAX_UINT (on 32bit systems at this time)
	 * and is 10 bytes long
	 */
	static char local[22];
	char *p = &local[21];
	*p-- = '\0';
	do{
		*p-- = '0' + i%10;
		i/=10;
	}while(i>0);
	return p+1;
}
